<?php
/*
  METHOD DEFINITIONS: Defines functions that can be called by clients (through XML).  Those functions retrieve the
  data and send it back to the client, wrapped in XML.
  Included in server.php
*/

/* ----------------------- */
/* MISCELLANEOUS FUNCTIONS */
/* ----------------------- */
/* Function for when the request method name doesn't exist */
function XMLRPC_method_not_found($methodName) { XMLRPC_error("2", "The method you requested, " . $methodName . ", was not found.", KD_XMLRPC_USERAGENT); }
/* Now a useful function for converting MySQL datetime to a UNIX timestamp which can then be used with the XMLRPC_convert_timestamp_to_iso8601($timestamp) function. This is not a method! It comes from: http://www.zend.com/codex.php?id=176&single=1 */
function mysql_datetime_to_timestamp($dt) {  
$yr=strval(substr($dt,0,4));  
$mo=strval(substr($dt,5,2));  
$da=strval(substr($dt,8,2));  
$hr=strval(substr($dt,11,2));  
$mi=strval(substr($dt,14,2));  
$se=strval(substr($dt,17,2));  
return mktime($hr,$mi,$se,$mo,$da,$yr);  
}

/* -------------------------------------------------------------- */
/* DEFINE METHODS - FUNCTION "POINTERS" WHICH HANDLE WEB REQUESTS */
/* -------------------------------------------------------------- */
/* Define an array to name the xmlrpc methods and their corresponding PHP Functions */
$xmlrpc_methods = array();
$xmlrpc_methods['block.getData'] = block_getData;
$xmlrpc_methods['method_not_found'] = XMLRPC_method_not_found;

/* --------------------------------------------------------------- */
/* DEFINE FUNCTIONS WHICH THE CLIENT REQUESTS IN ORDER TO GET DATA */
/* --------------------------------------------------------------- */
/* Cooresponds to the block.getData method */
function block_getData($query_info) {
$number = 0; $text = "";
$dataBlock = array();
$dataBlockBuild = array();

// Arguments can be passed into this function via $query_info
if (ISSET($query_info['number'])) { $number = $query_info['number']; }
if (ISSET($query_info['text'])) { $text = $query_info['text']; }

// Grab data to return - simulating three rows of data from a database
for ($x = 0; $x < 3; $x++) {
			    /* Extract the variables we want from the row */
			    $dataBlockBuild['id'] = $x;
			    $dataBlockBuild['field1'] = "field 1 data";
			    $dataBlockBuild['field2'] = "field 2 data";
			    $dataBlockBuild['field3'] = "field 3 data";
			    $dataBlockBuild['field4'] = "field 4 data";
			    $dataBlockBuild['field5'] = "field 5 data";
			    $dataBlockBuild['field6'] = "field 6 data";
			    $dataBlockBuild['field7'] = "field 7 data";
			    $dataBlockBuild['field8'] = "field 8 data";
			    $dataBlockBuild['field9'] = "field 9 data";
			    $dataBlockBuild['field10'] = "field 10 data";

			    /* Add to the $dataBlock array */
			    $dataBlock[] = $dataBlockBuild;
			   }

/* Convert the $dataBlock array to a set of XML-RPC parameters then respond with the XML. */
XMLRPC_response(XMLRPC_prepare($dataBlock), KD_XMLRPC_USERAGENT);
}

?>